// DirLightHelper

float4 LightDirection;	// xyz - direction, w - user defined
float3 LightAmbient;
float3 LightDiffuse;
float3 LightSpecular;

float CalcDiffuseCoeff(float3 aNormal)
{
	return dot(aNormal, -LightDirection.xyz);
}

float CalcDiffuseCoeff(float3 aNormal, float aClampMin, float aClampMax)
{
	return clamp(dot(aNormal, -LightDirection.xyz), aClampMin, aClampMax);
}

float3 CalcDiffuse(float3 aNormal)
{
	return LightDiffuse * CalcDiffuseCoeff(aNormal);
}

float3 CalcDiffuse(float3 aNormal, float aClampMin, aClampMax)
{
	return LightDiffuse * CalcDiffuseCoeff(aNormal, aClampMin, aClampMax);
}

float CalcSpecularCoeff1(float aEyePos, float aVertex, float aNormal)
{
	float3 h(normalize(normalize(aEyePos, aVertex) - LightDirection.xyz));
	return pow(dot(aNormal,h), 16);
}

void CalcDiffuseSpecular(float3 aNormal, float3 aEyePos, float3 aVertex, 
	float aClampMin, float aClampMax, out float3 retDiffuse, out float3 retSpecular)
{
	float d(CalcDiffuseCoeff(aNormal, aClampMin, aClampMax));
	rDiffuse = LightDiffuse * d;
	rSpecular = LightSpecular * CalcSpecularCoeff1(aEyePos, aVertex, aNormal) * (d >0 ? 1 : 0);
}

