float4 vPosition;
float4 vColor;

float3 GetPointLightColor(float3 vWorldPos, float3 vNormal)
{
	float3 ld = vPosition.xyz - vWorldPos;
	float d = length(ld);
	float coeff = max(dot(vNormal, ld / d), 0);
	float att = max(1 - d * d / vPosition.w, 0);
	return vColor.xyz * vColor.w * att * coeff;
}

struct vsDeferLightOutput
{
	float4 vPos			:POSITION;		//  
	float4 vTPos		:TEXCOORD0;		// 
	float3 vTNormal		:TEXCOORD1;
};

float4 CalcDeferLightPSColor(float4 vTPos, float3 vTNormal)
{
	return float4(vTNormal, (1 - vTPos.z/vTPos.w) * 888);
}

float4 psDeferLightDef(vsDeferLightOutput vIn):COLOR0
{
	return CalcDeferLightPSColor(vIn.vTPos, vIn.vTNormal);
}

#define DEFER_LIGHT_PASS_OPTIONS \
		CullMode = CCW; \
		FillMode = Solid; \
		AlphaBlendEnable = false; \
		SrcBlend = SrcAlpha; \
		DestBlend = InvSrcAlpha; \
		AlphaFunc = GreaterEqual; \
		AlphaTestEnable = false; \
		PointSpriteEnable = false; \
		ZEnable = true; \
		ZWriteEnable = true; \
		MultiSampleAntiAlias = false; \
		StencilEnable = false; 


#define TECH_DEFER_LIGHT_DEFAULT \
technique TechDeferLightDef \
{ \
	pass pass1 \
	{ \
		CullMode=CCW; \
		FillMode=Solid; \
		AlphaBlendEnable=false; \
		SrcBlend=SrcAlpha; \
		DestBlend=InvSrcAlpha; \
		AlphaFunc=GreaterEqual; \
		AlphaTestEnable=false; \
		PointSpriteEnable=false; \
		ZEnable=true; \
		ZWriteEnable=true; \
		StencilEnable = false; \
		MultiSampleAntiAlias = false; \
		VertexShader=compile vs_2_0 vsDeferLight(); \
		PixelShader=compile ps_2_0 psDeferLightDef(); \
	} \
};

#define DEFER_LIGHT_DEF_PS \
	PixelShader=compile ps_2_0 psDeferLightDef();


#define TECH_DEFER_LIGHT_BEGIN \
technique TechDeferLightDef \
{ \
	pass pass1 \
	{ \
		CullMode=CCW; \
		FillMode=Solid; \
		AlphaBlendEnable=false; \
		SrcBlend=SrcAlpha; \
		DestBlend=InvSrcAlpha; \
		AlphaFunc=GreaterEqual; \
		AlphaTestEnable=false; \
		PointSpriteEnable=false; \
		ZEnable=true; \
		ZWriteEnable=true; \
		MultiSampleAntiAlias = false; \
		StencilEnable = false; 
		
#define TECH_DEFER_LIGHT_END \
	} \
};

