//-----------------------------------------------------------------
// Brush drawing Effect
// 
#include "Inc/TL.fx"

texture	tFontTexture:register(t0);

sampler sFontSampler= sampler_state
{
	Texture=<tFontTexture>;
	AddressU = Clamp;
	AddressV = Clamp;
//	AddressW = Clamp;
	MinFilter = Point;
	MipFilter = None;
	MagFilter = Linear;
};

struct vsInput
{
	float3 vPos		:POSITION;
	float4 vColor	:COLOR0;
	float2 vTex		:TEXCOORD0;
};

struct vsOutput
{
	float4 vPos		:POSITION;
	float4 vColor	:COLOR0;
	float2 vTex		:TEXCOORD0;
};

vsOutput vsDefault(vsInput vIn)
{
	vsOutput vOut;
	vOut.vPos = TLFromPixels(vIn.vPos);
	vOut.vColor = vIn.vColor;
	vOut.vTex = vIn.vTex;
	return vOut;
}


float4 psDefault(vsOutput vIn):COLOR0
{
	float clr = tex2D(sFontSampler, vIn.vTex).x;
	return float4(vIn.vColor.xyz, clr * vIn.vColor.w);
}


// Font Technique



technique TechDefault
{
	pass Pass1
	{
		ZEnable=true;
		ZWriteEnable=false;
		AlphaBlendEnable = true;
		SrcBlend = SrcAlpha;
		DestBlend = InvSrcAlpha;
		AlphaTestEnable=false;
		AlphaRef=0x00;
		AlphaFunc=GreaterEqual;
		FillMode = Solid;
		CullMode = CCW;
		StencilEnable = false;
		MultiSampleAntiAlias = false;
		PointSpriteEnable=false;
		VertexShader = compile vs_2_0 vsDefault();
		PixelShader = compile ps_2_0 psDefault();
	}
}
