//-----------------------------------------------------------------
// Brush drawing Effect
// 

float4x4	matViewProj;
float4		cBrushColor;
texture		tBrushTexture:register(t0);

sampler sBrushSampler= sampler_state
{
	Texture=<tBrushTexture>;
	AddressU = Border;
	AddressV = Border;
	AddressW = Border;
	BorderColor = 0x00000000;
	MinFilter = Linear;
	MipFilter = None;
	MagFilter = Linear;
};

struct vsInput
{
	float4 vPos		:POSITION;
	float2 vTex		:TEXCOORD0;
};

struct vsOutput
{
	float4 vPos		:POSITION;
	float2 vTex		:TEXCOORD0;
};

vsOutput vsDefault(vsInput vIn)
{
	vsOutput vOut;
	vOut.vPos = mul(/*float4(vIn.vPos,1)*/vIn.vPos, matViewProj);
	vOut.vTex = vIn.vTex;
	return vOut;
}

float4 psDefault(vsOutput vIn):COLOR0
{
	float4 clr = tex2D(sBrushSampler, vIn.vTex);
	return float4(clr.xyz * cBrushColor.xyz, clr.a * (cBrushColor.a * 0.7 + 0.3));
}

// Brush Technique



technique Default
{
	pass Pass1
	{
		CullMode = CCW;
		AlphaBlendEnable = true;
		SrcBlend = SrcAlpha;
		DestBlend = InvSrcAlpha;
		FillMode = Solid;
		PointSpriteEnable=false;
		ZEnable=true;
		ZWriteEnable=true;
		StencilEnable = false;
		AlphaTestEnable=false;
		MultiSampleAntiAlias = false;
		VertexShader = compile vs_2_0 vsDefault();
		PixelShader = compile ps_2_0 psDefault();
	}
}
