///////////////////////////////////////////////////////////////////////////////////
//         
///////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////
// VARIABLES
///////////////////////////////////////////////////////////////////////////////////

float4x4	matWorld;		// World Transform
float4x4	matViewProj;	// ViewProj Transform
float4		vParams;		// x - FillMode, y - zEnable, z - ZWriteEnable, w - AlphaBlendEnable
float4		vColor;			//  

///////////////////////////////////////////////////////////////////////////////////
// SHADERS
///////////////////////////////////////////////////////////////////////////////////

float4 vsDefault(float4 vPos:POSITION):POSITION 
{
	return mul(vPos,mul(matWorld,matViewProj));
}

float4 psDefault(float4 vPos:POSITION):COLOR0
{
	return vColor;
}

technique Default
{
	Pass Pass1
	{
		CullMode=CCW;
		AlphaBlendEnable=(vParams.w);
		ZEnable=(vParams.y);
		ZWriteEnable=(vParams.z);
		SrcBlend=SrcAlpha;
		DestBlend=InvSrcAlpha;
		FillMode=(vParams.x);
		StencilEnable = false;
		AlphaTestEnable=false;
		PointSpriteEnable=false;
		MultiSampleAntiAlias = false;
		VertexShader=compile vs_2_0 vsDefault();
		PixelShader=compile ps_2_0 psDefault();
	}
}






