///////////////////////////////////////////////////////////////////////////////////
//         
///////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////
// VARIABLES
///////////////////////////////////////////////////////////////////////////////////
float4		vOrigin;		// xyz - Origin for vertices (absolute or relative);
float4		vInvScreenSize;	// xy - screensize, zw - ScreenScaleCoeff (Sx-2/Sx, Sy-2/Sy);
float4		vParams;		// x - FillMode, y - relative origin=1, z - relative vertices=1, w - AlphaBlendEnable
float4		vColor;			//  

///////////////////////////////////////////////////////////////////////////////////
// SHADERS
///////////////////////////////////////////////////////////////////////////////////

float4 vsDefault(float3 vPos:POSITION):POSITION 
{
	// x,y = relative or absolute vertex screen coordinates;
	float2 korig=(vParams.y>0.5 ? vInvScreenSize.xy : float2(1,1));
	float2 kvert=(vParams.z>0.5 ? vInvScreenSize.xy : float2(1,1));
	return float4(2*vPos.x*vInvScreenSize.z*kvert.x-1,1-2*vPos.y*vInvScreenSize.w*kvert.y,vPos.z,1);
//	return float4(2-2*(vOrigin.x*korig.x+vPos.x*kvert.x),2*(vOrigin.y*korig.y+vPos.y*kvert.y)-2,vPos.z,1);
//	return float4(vPos.x*vInvScreenSize.z,vPos.y*vInvScreenSize.w,vPos.z,1);
}

float4 psDefault(float4 vPos:POSITION):COLOR0
{
	return vColor;
}

technique Default
{
	Pass Pass1
	{
		CullMode=CCW;
		AlphaBlendEnable=(vParams.w);
		ZEnable=false;
		ZWriteEnable=false;
		SrcBlend=SrcAlpha;
		DestBlend=InvSrcAlpha;
		FillMode=(vParams.x);
		StencilEnable = false;
		AlphaTestEnable=false;
		PointSpriteEnable=false;
		MultiSampleAntiAlias = false;
		VertexShader=compile vs_2_0 vsDefault();
		PixelShader=compile ps_2_0 psDefault();
	}
}






