///////////////////////////////////////////////////////////////////////////////////
//         
///////////////////////////////////////////////////////////////////////////////////

#include "Inc/TL.fx"

///////////////////////////////////////////////////////////////////////////////////
// SHADERS
///////////////////////////////////////////////////////////////////////////////////

struct vsIn
{
	float3 vPos : POSITION;
	float4 vColor : COLOR0;
};

struct vsOut
{
	float4 vPos : POSITION;
	float4 vColor : COLOR0;
};

vsOut vsDefault(vsIn vIn)
{
	vsOut vOut;
	vOut.vPos = TLFromPixels(vIn.vPos);
	vOut.vColor= vIn.vColor;
	return vOut;
}

float4 psDefault(vsOut vIn):COLOR0
{
	return vIn.vColor;
}

technique Default
{
	Pass Pass1
	{
		CullMode=CCW;
		AlphaBlendEnable=true;
		ZEnable=true;
		ZWriteEnable=true;
		SrcBlend=SrcAlpha;
		DestBlend=InvSrcAlpha;
		FillMode=Solid;
		AlphaTestEnable=false;
		PointSpriteEnable=false;
		StencilEnable = false;
		MultiSampleAntiAlias = false;
		VertexShader=compile vs_2_0 vsDefault();
		PixelShader=compile ps_2_0 psDefault();
	}
}






