///////////////////////////////////////////////////////////////////////////////////
// draw 2d object with simple texture
///////////////////////////////////////////////////////////////////////////////////
#include "Inc/TL.fx"
texture tTexture;

///////////////////////////////////////////////////////////////////////////////////
// SHADERS
///////////////////////////////////////////////////////////////////////////////////

sampler sTexture = sampler_state
{
	Texture=(tTexture);
//	AddressU = Border;
//	AddressV = Border;
//	AddressW = Clamp;
	BorderColor = 0x00000000;
	MinFilter=Linear;
	MipFilter=None;
	MagFilter=Linear;	
};

struct vsIn
{
	float3 vPos : POSITION;
	float2 vTex	: TEXCOORD0;
	float4 vColor: COLOR0;
};

struct vsOut
{
	float4 vPos : POSITION;
	float2 vTex : TEXCOORD0;
	float4 vColor: COLOR0;
};

vsOut vsDefault(vsIn vIn)
{
	vsOut vOut;
	vOut.vPos = TLFromPixels(vIn.vPos);
	vOut.vTex= vIn.vTex;
	vOut.vColor = vIn.vColor;
	return vOut;
}

float4 psDefault(vsOut vIn):COLOR0
{
	float4 color = tex2D(sTexture, vIn.vTex);
	return float4(color.xyz * vIn.vColor.xyz, color.w);
}

technique Default
{
	Pass Pass1
	{
		CullMode=CCW;
		AlphaBlendEnable=true;
		ZEnable=true;
		ZWriteEnable=true;
		SrcBlend=SrcAlpha;
		DestBlend=InvSrcAlpha;
		FillMode=Solid;
		AlphaTestEnable=true;
		AlphaRef=0x00;
		PointSpriteEnable=false;
		StencilEnable = false;
		MultiSampleAntiAlias = false;
		VertexShader=compile vs_2_0 vsDefault();
		PixelShader=compile ps_2_0 psDefault();
	}
}
