// Draw texture with coloring up to 8 regions by mask with alpha

#include "Inc/TL.fx"

#define MAX_COLORS 16

texture tMask;
float4 cColors[MAX_COLORS];

///////////////////////////////////////////////////////////////////////////////////
// SHADERS
///////////////////////////////////////////////////////////////////////////////////

sampler sMask = sampler_state
{
	Texture=(tMask);
//	AddressU = Border;
//	AddressV = Border;
//	AddressW = Clamp;
	BorderColor = 0x00000000;
	MinFilter=Point;
	MipFilter=Point;
	MagFilter=Point;	
};


struct vsIn
{
	float3 vPos : POSITION;
	float2 vTex	: TEXCOORD0;
};

struct vsOut
{
	float4 vPos : POSITION;
	float2 vTex : TEXCOORD0;
};

vsOut vsDefault(vsIn vIn)
{
	vsOut vOut;
	vOut.vPos = TLFromPixels(vIn.vPos);
	vOut.vTex= vIn.vTex;
	return vOut;
}

float4 psDefault(vsOut vIn):COLOR0
{
	float mask = tex2D(sMask, vIn.vTex).x;
	float4 modclr = cColors[mask * 16];
	if (mask < 0.01) return 0;
	else return modclr;
//	return float4(srcclr.xyz * (1 - modclr.w) + modclr.xyz * modclr.w, srcclr.w);
}

technique Default
{
	Pass Pass1
	{
		CullMode=CCW;
		AlphaBlendEnable=true;
		ZEnable=true;
		ZWriteEnable=true;
		SrcBlend=SrcAlpha;
		DestBlend=InvSrcAlpha;
		FillMode=Solid;
		AlphaTestEnable=true;
		AlphaRef=0x00;
		AlphaFunc = Greater;
		PointSpriteEnable=false;
		StencilEnable = false;
		MultiSampleAntiAlias = false;
		VertexShader=compile vs_2_0 vsDefault();
		PixelShader=compile ps_2_0 psDefault();
	}
}






//EOF