///////////////////////////////////////////////////////////////////////////////////
// draw 2d object with simpletexture and fog
///////////////////////////////////////////////////////////////////////////////////
#include "Inc/TL.fx"
#include "Inc/WarFog.fx"
texture tTexture;

static float3 togray = float3(0.2989, 0.587, 0.114);

///////////////////////////////////////////////////////////////////////////////////
// SHADERS
///////////////////////////////////////////////////////////////////////////////////

sampler sTexture = sampler_state
{
	Texture=(tTexture);
//	AddressU = Border;
//	AddressV = Border;
//	AddressW = Clamp;
	BorderColor = 0x00000000;
	MinFilter=Linear;
	MipFilter=None;
	MagFilter=Linear;	
};

struct vsIn
{
	float3 vPos : POSITION;
	float2 vTex	: TEXCOORD0;
	float4 vColor : COLOR0;
};

struct vsOut
{
	float4 vPos : POSITION;
	float2 vTex : TEXCOORD0;
	float3 vFogCoords : TEXCOORD1;
	float4 vColor : COLOR0;
};

vsOut vsDefault(vsIn vIn)
{
	vsOut vOut;
	vOut.vPos = TLFromPixels(vIn.vPos);
	vOut.vTex= vIn.vTex;
	vOut.vColor = vIn.vColor;
	vOut.vFogCoords = float3(vIn.vTex.x, 1-vIn.vTex.y, 1);
	return vOut;
}

float4 psDefault(vsOut vIn):COLOR0
{
	float3 color = tex2D(sTexture, vIn.vTex).xyz * GetWarFog(vIn.vFogCoords, 0.4, 0.6);
	if (vIn.vColor.w > 0.5) return float4(color, 1);
	else return float4(color * 0.85 + vIn.vColor.xyz * 0.15, 1);
}

technique Default
{
	Pass Pass1
	{
		CullMode=CCW;
		AlphaBlendEnable=false;
		ZEnable=true;
		ZWriteEnable=true;
		SrcBlend=SrcAlpha;
		DestBlend=InvSrcAlpha;
		FillMode=Solid;
		AlphaTestEnable=false;
//		AlphaRef=0x05;
		PointSpriteEnable=false;
		StencilEnable = false;
		MultiSampleAntiAlias = false;
		VertexShader=compile vs_2_0 vsDefault();
		PixelShader=compile ps_2_0 psDefault();
	}
}
