///////////////////////////////////////////////////////////////////////////////////
// draw 2d object with simple texture
///////////////////////////////////////////////////////////////////////////////////

float4 vInvScreenSize;		// x = 1/Width, y = 1/Height
texture tTextureFrom;
texture tTextureTo;
float vCoeff;

///////////////////////////////////////////////////////////////////////////////////
// SHADERS
///////////////////////////////////////////////////////////////////////////////////

sampler sTextureFrom = sampler_state
{
	Texture=(tTextureFrom);
	MinFilter=Linear;
	MipFilter=Linear;
	MagFilter=Linear;	
};

sampler sTextureTo = sampler_state
{
	Texture=(tTextureTo);
	MinFilter=Linear;
	MipFilter=Linear;
	MagFilter=Linear;	
};


struct vsIn
{
	float3 vPos : POSITION;
	float2 vTex	: TEXCOORD0;
};

struct vsOut
{
	float4 vPos : POSITION;
	float2 vTex : TEXCOORD0;
};

vsOut vsDefault(vsIn vIn)
{
	vsOut vOut;
	vOut.vPos = float4(2*vIn.vPos.x*vInvScreenSize.x-1,1-2*vIn.vPos.y*vInvScreenSize.y, vIn.vPos.z,1);
	vOut.vTex= vIn.vTex;
	return vOut;
}

float4 psDefault(vsOut vIn):COLOR0
{
//	return 1;
	float4 c1 = tex2D(sTextureFrom, vIn.vTex);
	float4 c2 = tex2D(sTextureTo, vIn.vTex);
	float4 d = c2-c1;
	return c1+(c2-c1)*vCoeff;
}

technique Default
{
	Pass Pass1
	{
		CullMode=CCW;
		AlphaBlendEnable=true;
		ZEnable=true;
		ZWriteEnable=true;
		SrcBlend=SrcAlpha;
		DestBlend=InvSrcAlpha;
		FillMode=Solid;
//		AlphaTestEnable=true;
//		AlphaRef=0x10;
		PointSpriteEnable=false;
		StencilEnable = false;
		VertexShader=compile vs_2_0 vsDefault();
		PixelShader=compile ps_2_0 psDefault();
	}
}






