//-----------------------------------------------------------------
// Simple textured drawing Effect
// 

float4x4	matViewProj;
texture		tTexture:register(t0);

sampler sSampler= sampler_state
{
	Texture=<tTexture>;
	AddressU = Wrap;
	AddressV = Wrap;
	AddressW = Wrap;
	MinFilter = Linear;
	MipFilter = None;
	MagFilter = Linear;
};

struct vsInput
{
	float4 vPos		:POSITION;
	float2 vTex		:TEXCOORD0;
};

struct vsOutput
{
	float4 vPos		:POSITION;
	float2 vTex		:TEXCOORD0;
};

vsOutput vsDefault(vsInput vIn)
{
	vsOutput vOut;
	vOut.vPos = mul(vIn.vPos, matViewProj);
	vOut.vTex = vIn.vTex;
	return vOut;
}

float4 psDefault(vsOutput vIn):COLOR0
{
	return tex2D(sSampler, vIn.vTex);
}

// Brush Technique



technique Default
{
	pass Pass1
	{
		CullMode = CCW;
		AlphaBlendEnable = true;
		SrcBlend = SrcAlpha;
		DestBlend = InvSrcAlpha;
		FillMode = Solid;
		PointSpriteEnable=false;
		ZEnable=true;
		ZWriteEnable=true;
		StencilEnable = false;
		AlphaTestEnable=false;
		MultiSampleAntiAlias = false;
		VertexShader = compile vs_2_0 vsDefault();
		PixelShader = compile ps_2_0 psDefault();
	}
}
