//simpleskin.fx
float4x4 matWorld[3];
float4x4 matViewProj;

struct VS_OUT
{
	float4 vPos :POSITION;
	float4 vDiff:COLOR0;
};

struct VS_IN
{
	float3 vPos:POSITION;
	float4 vIdx:BLENDINDICES;
	float4 vDiff:COLOR0;
};

VS_OUT VShader(VS_IN vIn)
{
	VS_OUT vOut;
	vOut.vPos=mul(float4(vIn.vPos,1),matWorld[vIn.vIdx.x]);
	vOut.vPos=mul(vOut.vPos,matViewProj);
	vOut.vDiff=vIn.vDiff;
	return vOut;
}

technique SimpleSkin
{
	pass Pass1
	{
		VertexShader=compile vs_1_1 VShader();
		PixelShader=null;
	}
}