///////////////////////////////////////////////////////////////////////////////////
// draw 2d object with simple texture
///////////////////////////////////////////////////////////////////////////////////
#include "Inc/TL.fx"
float4 vPosition;
float4 vTexCoords;
texture tTexture;

///////////////////////////////////////////////////////////////////////////////////
// SHADERS
///////////////////////////////////////////////////////////////////////////////////

sampler sTexture = sampler_state
{
	Texture=(tTexture);
	AddressU = Border;
	AddressV = Border;
//	AddressW = Clamp;
	BorderColor = 0x00000000;
	MinFilter=Linear;
	MipFilter=Linear;
	MagFilter=Linear;	
};

struct vsIn
{
	float3 vPos : POSITION;
	float2 vTex	: TEXCOORD0;
};

struct vsOut
{
	float4 vPos : POSITION;
	float2 vTex : TEXCOORD0;
};

vsOut vsDefault(vsIn vIn)
{
	vsOut vOut;
	float3 vPos = float3(
		vIn.vPos.x > 0.5 ? vPosition.z : vPosition.x,
		vIn.vPos.y > 0.5 ? vPosition.w : vPosition.y,
		vIn.vPos.z);
	vOut.vPos = TLFromPixels(vPos);
	vOut.vTex= float2(
		vIn.vTex.x > 0.5 ? vTexCoords.z : vTexCoords.x,
		vIn.vTex.y > 0.5 ? vTexCoords.w : vTexCoords.y);
	return vOut;
}

float4 psDefault(vsOut vIn):COLOR0
{
	return tex2D(sTexture, vIn.vTex);
}

technique Default
{
	Pass Pass1
	{
		CullMode=None;
		AlphaBlendEnable=true;
		ZEnable=true;
		ZWriteEnable=true;
		SrcBlend=SrcAlpha;
		DestBlend=InvSrcAlpha;
		FillMode=Solid;
		AlphaTestEnable=true;
		AlphaRef=0x10;
		PointSpriteEnable=false;
		StencilEnable = false;
		MultiSampleAntiAlias = false;
		VertexShader=compile vs_2_0 vsDefault();
		PixelShader=compile ps_2_0 psDefault();
	}
}
