///////////////////////////////////////////////////////////////////////////////////
//         
///////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////
// VARIABLES
///////////////////////////////////////////////////////////////////////////////////
float4		vOrigin;		// xyz - Origin for vertices (absolute or relative);
float4		vInvScreenSize;	// xy - screensize, zw - ScreenScaleCoeff (Sx-2/Sx, Sy-2/Sy);
float4		vParams;		// x - FillMode, y - relative origin=1, z - relative vertices=1, w - AlphaBlendEnable
texture		tTexture:register(t0);		//  

sampler sBaseSampler=sampler_state
{
	Texture=<tTexture>;
	AddressU = Clamp;
	AddressV = Clamp;
//	AddressW = Clamp;
	MinFilter = Linear;
	MipFilter = none;
	MagFilter = Linear;
};

///////////////////////////////////////////////////////////////////////////////////
// SHADERS
///////////////////////////////////////////////////////////////////////////////////

struct vsInput
{
	float3 vPos:POSITION;
	float2 vTex:TEXCOORD0;
};


struct vsOutput
{
	float4 vPos:POSITION;
	float2 vTex:TEXCOORD0;
};

vsOutput vsDefault(vsInput vIn)
{
	vsOutput vOut;
	// x,y = relative or absolute vertex screen coordinates;
	float2 korig=(vParams.y>0.5 ? vInvScreenSize.xy : float2(1,1));
	float2 kvert=(vParams.z>0.5 ? vInvScreenSize.xy : float2(1,1));
	vOut.vPos=float4(2*(vIn.vPos.x+vOrigin.x)*vInvScreenSize.z*kvert.x-1,1-2*(vIn.vPos.y+vOrigin.y)*vInvScreenSize.w*kvert.y,vIn.vPos.z,1);
//	vOut.vPos+=float4(2*vOrigin.x*vInvScreenSize.z*korig.x-1,1-2*vOrigin.y*vInvScreenSize.w*korig.y,vOrigin.z,1);
//	vOut.vPos=float4(vIn.vPos+vOrigin,1);
	vOut.vTex=vIn.vTex;
	return vOut;
//	return float4(2-2*(vOrigin.x*korig.x+vPos.x*kvert.x),2*(vOrigin.y*korig.y+vPos.y*kvert.y)-2,vPos.z,1);
//	return float4(vPos.x*vInvScreenSize.z,vPos.y*vInvScreenSize.w,vPos.z,1);
}

float4 psDefault(vsOutput vIn):COLOR0
{
	return tex2D(sBaseSampler,vIn.vTex);
}

technique Default
{
	Pass Pass1
	{
		CullMode=CCW;
		AlphaBlendEnable=(vParams.w);
		ZEnable=false;
		ZWriteEnable=false;
		SrcBlend=SrcAlpha;
		DestBlend=InvSrcAlpha;
		FillMode=(vParams.x);
		AlphaTestEnable=false;
		PointSpriteEnable=false;
		StencilEnable = false;
		MultiSampleAntiAlias = false;
		VertexShader=compile vs_2_0 vsDefault();
		PixelShader=compile ps_2_0 psDefault();
	}
}






