///////////////////////////////////////////////////////////////////////////////////
//         
///////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////
// VARIABLES
///////////////////////////////////////////////////////////////////////////////////

float4x4	matWorld;		// World Transform
float4x4	matViewProj;	// ViewProj Transform
float4		vParams;		// x - FillMode, y - zEnable, z - ZWriteEnable, w - AlphaBlendEnable

struct vsInput
{
	float3 vPos: POSITION;
	float4 vColor: COLOR0;
};

struct vsOutput
{
	float4 vPos:POSITION;
	float4 vColor: COLOR0;
};

///////////////////////////////////////////////////////////////////////////////////
// SHADERS
///////////////////////////////////////////////////////////////////////////////////

vsOutput vsDefault(vsInput vIn)
{
	vsOutput o;
	o.vPos = mul(float4(vIn.vPos, 1), mul(matWorld, matViewProj));
	o.vColor = vIn.vColor;
	return o;
}

float4 psDefault(vsOutput vIn):COLOR0
{
	return vIn.vColor;
}

technique Default
{
	Pass Pass1
	{
		CullMode=CCW;
		AlphaBlendEnable=(vParams.w);
		ZEnable=(vParams.y);
		ZWriteEnable=(vParams.z);
		SrcBlend=SrcAlpha;
		DestBlend=InvSrcAlpha;
		FillMode=(vParams.x);
		AlphaTestEnable=false;
		PointSpriteEnable=false;
		StencilEnable = false;
		MultiSampleAntiAlias = false;
		VertexShader=compile vs_2_0 vsDefault();
		PixelShader=compile ps_2_0 psDefault();
	}
}






